### Release

> *Important* Don't forget to replace `${version}` by your real version like `0.1.3`!

- Clean build dirs `cargo clean`
- Ensure build `cargo build --release` and tests `cargo test --target aarch64-apple-darwin` pass (adapt `--target` value to fit your machine's architecture)
- Ensure you are in a clean and pushed Git state
- Find & replace all occurrences of Regex `^version = "[^"]+"` in all `Cargo.toml` files to `version = "${version}"`
- Find & replace all occurrences of Regex `^substreams-ethereum(-[^ =]+)?\s*=\s*\{\s*version\s*=\s*"[^"]+"` in all `Cargo.toml` files to `substreams-ethereum$1 = { version = "${version}"`
- Update the [CHANGELOG.md](CHANGELOG.md) to update the `## Next` header to become `## [${version}](https://github.com/streamingfast/substreams-ethereum/releases/tag/v${version})`
- Ensure that Keybase is running and logged in
- Ensure that `cargo login` has been done in your terminal
- Ensure build `cargo build --release` and tests `cargo test --target aarch64-apple-darwin` still pass (adapt `--target` value to fit your machine's architecture)
- Commit everything with message `Preparing release of ${version}`.
- `./bin/release.sh -f v${version}`
- If everything goes well, `crates.io` will be update and Git should be in a synced state (the release script does a `git push` of the branch and the tag).
- Go to https://github.com/streamingfast/substreams-ethereum/releases and edit the draft release named `v${version}`.
- Update the release notes, use content of section `## [v${version}]` in [CHANGELOG.md](CHANGELOG.md), edit GitHub release and paste content before commits listing, keep both:

  ```
  ## Changelog

  <Content from 'docs/release-notes/change-log.md' here>

  ### Commits

  <Auto-generated commits listing>
  ```

- Publish the draft release (**Important** Don't forget this step otherwise release will not be published out!)
- Update the [CHANGELOG.md](CHANGELOG.md) adding `## Next` header on top of latest released section.
- Commit everything with message `Preparing next version`.
- Git push again (`git push origin develop`)

You can then update the https://github.com/streamingfast/substreams-template with the latest.

## Community

Need any help? Reach out!

* [StreamingFast Discord](https://discord.gg/jZwqxJAvRs)
* [The Graph Discord](https://discord.gg/vtvv7FP)

## License

[Apache 2.0](LICENSE)
